## caveexpress 2.4%2Bgit20160609

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.7)
project(caveproductions)

#-------------------------------------------------------------------------------
# options
#-------------------------------------------------------------------------------

option(NETWORKING "Enable networking" ON)
option(UNITTESTS "Builds with unittests" ON)
option(TOOLS "Builds with tools" ON)
option(VERBOSE "Print debug information" OFF)
option(COVERAGE "Compile with test coverage" OFF)
option(USE_CCACHE "Use ccache" ON)
option(CAVEEXPRESS "Build caveexpress" ON)
option(CAVEPACKER "Build cavepacker" ON)
option(MINIRACER "Build miniracer" OFF)
option(SANITIZER "Build with sanitizer support if available" ON)

#-------------------------------------------------------------------------------
# end options
#-------------------------------------------------------------------------------

if (NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE "Debug" CACHE STRING "Compile Type" FORCE)
endif()
set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS Debug Release MinSizeRel RelWithDebInfo)

if (${CMAKE_BUILD_TYPE} MATCHES "Debug")
	set(RELEASE False)
else()
	set(RELEASE True)
endif()

set(ROOT_DIR ${CMAKE_CURRENT_SOURCE_DIR} CACHE STRING "Root dir")
message(STATUS "Place binaries in ${ROOT_DIR}")
# First for the generic no-config case (e.g. with mingw)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${ROOT_DIR})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/${CMAKE_BUILD_TYPE}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/${CMAKE_BUILD_TYPE}/lib)

# Second, for multi-config builds (e.g. msvc)
foreach(OUTPUTCONFIG ${CMAKE_CONFIGURATION_TYPES})
	string(TOUPPER ${OUTPUTCONFIG} OUTPUTCONFIG)
	set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${ROOT_DIR})
	set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${CMAKE_BINARY_DIR}/${CMAKE_BUILD_TYPE}/lib)
	set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${CMAKE_BINARY_DIR}/${CMAKE_BUILD_TYPE}/lib)
endforeach()
set(DEFAULT_LUAC_EXECUTABLE luac)
set(CP_CMAKE_DIR ${PROJECT_SOURCE_DIR}/cmake)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CP_CMAKE_DIR})
set(CMAKE_VERBOSE_MAKEFILE ${VERBOSE})
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

if (${CMAKE_EXTRA_GENERATOR} MATCHES "Eclipse CDT4")
	message(STATUS "Generate eclipse projects")
	set(CMAKE_ECLIPSE_GENERATE_LINKED_RESOURCES OFF)
	set(CMAKE_ECLIPSE_GENERATE_SOURCE_PROJECT ON)
	set(CMAKE_ECLIPSE_VERSION "4.3" CACHE STRING "Eclipse version")
	set(CMAKE_CXX_COMPILER_ARG1 "-std=c++11" CACHE STRING "C++ version for Eclipse")
endif()

include(${CP_CMAKE_DIR}/macros.cmake)

if (COVERAGE)
	if ((CP_GCC OR CP_CLANG) AND NOT RELEASE)
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -O0 -fprofile-arcs -ftest-coverage")
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -O0 -fprofile-arcs -ftest-coverage")
	elseif (RELEASE)
		message(WARNING "Skip coverage, you attempt to compile in release mode")
	else()
		message(WARNING "Skip coverage, you don't compile with gcc or clang")
	endif()
endif()

cp_message("ROOT_DIR: ${ROOT_DIR}")
cp_message("CMAKE_MODULE_PATH: ${CMAKE_MODULE_PATH}")
cp_message("PROJECT_SOURCE_DIR: ${PROJECT_SOURCE_DIR}")
message(STATUS "CMAKE_SYSTEM_NAME: ${CMAKE_SYSTEM_NAME}")
message(STATUS "CMAKE_HOST_SYSTEM_NAME: ${CMAKE_HOST_SYSTEM_NAME}")

#-------------------------------------------------------------------------------
# variables
#-------------------------------------------------------------------------------

if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
	set(WINDOWS 1)
elseif (${CMAKE_SYSTEM_NAME} STREQUAL "Android")
	set(LINUX 1)
elseif (${CMAKE_SYSTEM_NAME} STREQUAL "Darwin")
	set(DARWIN 1)
elseif (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
	set(LINUX 1)
elseif (${CMAKE_SYSTEM_NAME} STREQUAL "Emscripten")
	set(EMSCRIPTEN 1)
else()
	message(WARNING "Unknown host system: ${CMAKE_SYSTEM_NAME}. Default to linux")
	set(LINUX 1)
endif()

include(${CP_CMAKE_DIR}/pack.cmake)
include(CPack)

# on mac it e.g. finds the gui launcher - this is not what we want - find a proper way to handle this
if (NOT ${CMAKE_HOST_SYSTEM_NAME} STREQUAL "Darwin")
	find_host_program(TEXTUREPACKER_BIN NAMES TexturePacker)
	if (${TEXTUREPACKER_BIN})
		message(STATUS "Found TexturePacker: ${TEXTUREPACKER_BIN}")
	else()
		message(STATUS "Could not find TexturePacker")
	endif()
endif()
if (NOT CMAKE_TOOLCHAIN_FILE)
	if (WINDOWS)
		include(${CP_CMAKE_DIR}/toolchains/windows-toolchain.cmake)
	elseif (DARWIN)
		include(${CP_CMAKE_DIR}/toolchains/darwin-toolchain.cmake)
	else()
		include(${CP_CMAKE_DIR}/toolchains/linux-toolchain.cmake)
	endif()
endif()

if (ANDROID)
	include(${CP_CMAKE_DIR}/android.cmake)
elseif (IOS)
	include(${CP_CMAKE_DIR}/ios.cmake)
elseif (DARWIN)
	include(${CP_CMAKE_DIR}/darwin.cmake)
elseif (WINDOWS)
#	include(${CP_CMAKE_DIR}/windows.cmake)
elseif (NACL)
	include(${CP_CMAKE_DIR}/nacl.cmake)
elseif (EMSCRIPTEN)
	include(${CP_CMAKE_DIR}/emscripten.cmake)
endif()

if (PKGDATADIR)
	add_definitions(-DPKGDATADIR="${PKGDATADIR}")
	message(STATUS "You specified a package data dir - but this means, you have to rebuild for each game.")
	message(STATUS "If you don't do this, you get all the data of all the games in the same directory.")
	message(STATUS "See the available options and disable all but one game for each build.")
endif()

if (NOT NETWORKING)
	add_definitions(-DNONETWORK=1)
endif()

if (NOT CMAKE_BUILD_TYPE)
	if (RELEASE)
		set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Compile Type" FORCE)
	else()
		set(CMAKE_BUILD_TYPE "Debug" CACHE STRING "Compile Type" FORCE)
	endif()
	set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS Debug Release)
endif()

find_host_program(CCACHE "ccache")
if (CCACHE)
	if (USE_CCACHE)
		message(STATUS "Using ccache")
		set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ${CCACHE})
		set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ${CCACHE})
	endif()
else()
	message(STATUS "ccache not found")
endif()

configure_file(${ROOT_DIR}/src/config.h.in ${CMAKE_BINARY_DIR}/cp-config.h)
include_directories(${CMAKE_BINARY_DIR})

include_directories(src)
include_directories(src/modules)
if (UNITTESTS)
	include_directories(src/libs/gtest)
	include_directories(src/libs/gtest/include)
endif()

add_subdirectory(src/libs)

# TODO move into lib cmakefiles
if (LUA5.2_FOUND)
	add_definitions(-DHAVE_LUA_H)
endif()
if (UNITTESTS)
	enable_testing()
endif()
add_subdirectory(src/modules)
if (CAVEPACKER)
	add_subdirectory(src/cavepacker)
endif()
if (CAVEEXPRESS)
	add_subdirectory(src/caveexpress)
endif()
if (MINIRACER)
	add_subdirectory(src/miniracer)
endif()
if (UNITTESTS)
	add_subdirectory(src/tests)
endif()

=== src/caveexpress/client/CMakeLists.txt ===
set(NAME caveexpress)
set(${NAME}-client_SRCS
	entities/ClientCaveTile.cpp
	entities/ClientNPC.cpp
	entities/ClientWindowTile.cpp
	entities/ClientParticle.cpp
	CaveExpressClientMap.cpp
	ui/nodes/UINodeMapEditor.cpp
	ui/nodes/UINodeBackgroundScene.cpp
	ui/nodes/UINodeMap.cpp
	ui/windows/UIGameOverWindow.cpp
	ui/windows/intro/IntroFlying.cpp
	ui/windows/intro/IntroFindYourWay.cpp
	ui/windows/intro/IntroGeyser.cpp
	ui/windows/intro/IntroTime.cpp
	ui/windows/intro/IntroTree.cpp
	ui/windows/intro/IntroPackage.cpp
	ui/windows/intro/IntroAttack.cpp
	ui/windows/UIGameFinishedWindow.cpp
	ui/windows/UIMapEditorOptionsWindow.cpp
	ui/windows/UIMapFailedWindow.cpp
	ui/windows/UICaveExpressSettingsWindow.cpp
	ui/windows/UIMainWindow.cpp
	ui/windows/UIGameHelpWindow.cpp
	ui/windows/UIMapEditorHelpWindow.cpp
	ui/windows/UIMapWindow.cpp
	ui/windows/UIMapEditorWindow.cpp
)
add_library(${NAME}-client ${${NAME}-client_SRCS})
set_target_properties(${NAME}-client PROPERTIES FOLDER ${NAME}-client)
cp_target_link_libraries(TARGET ${NAME}-client LIBS client ${NAME}-shared)

=== src/caveexpress/tools/CMakeLists.txt ===
project(jsonconvert)
SET(${PROJECT_NAME}_SRC JSONConvert.cpp)
add_executable(${PROJECT_NAME} ${${PROJECT_NAME}_SRC})
set_target_properties(${PROJECT_NAME} PROPERTIES FOLDER ${PROJECT_NAME})
cp_target_link_libraries(TARGET ${PROJECT_NAME} LIBS caveexpress-shared common yajl physics)

project(soundmapper)
SET(${PROJECT_NAME}_SRC SoundMapper.cpp)
add_executable(${PROJECT_NAME} ${${PROJECT_NAME}_SRC})
set_target_properties(${PROJECT_NAME} PROPERTIES FOLDER ${PROJECT_NAME})
cp_target_link_libraries(TARGET ${PROJECT_NAME} LIBS caveexpress-shared common)

=== src/miniracer/tests/CMakeLists.txt ===
set(NAME miniracer)
project(tests_${NAME})
set(${PROJECT_NAME}_SRC
	ProtocolTest.cpp
	LUASpriteTest.cpp
	MiniRacerMapContextTest.cpp
	MapManagerTest.cpp
	../main/MiniRacer.cpp
	../../tests/TestAll.cpp
	../../tests/TestShared.cpp
	../../tests/NetworkTest.cpp
	../../tests/NoNetworkTest.cpp
)
cp_add_executable(TARGET ${PROJECT_NAME} SRCS ${${PROJECT_NAME}_SRC} APPNAME ${PROJECT_NAME} VERSION 1.0 VERSION_CODE 1)
cp_target_link_libraries(TARGET ${PROJECT_NAME} LIBS ${NAME}-client ${NAME}-server ${NAME}-shared gtest)
add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})

=== src/modules/client/CMakeLists.txt ===
set(client_SRCS
	ClientConsole.cpp
	Camera.cpp
	ClientMap.cpp
	entities/ClientEntity.cpp
	entities/ClientPlayer.cpp
	entities/ClientMapTile.cpp
)
add_library(client ${client_SRCS})
set_target_properties(client PROPERTIES FOLDER client)
cp_target_link_libraries(TARGET client LIBS gfx particle service)

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/<project>-$1\.tar\.gz/ \
  https://github.com/mgerhardy/caveexpress/tags .*/v?(\d\S*)\.tar\.gz

## caveexpress 2.4+git20160609

=== src/caveexpress/CMakeLists.txt ===
add_subdirectory(shared)
add_subdirectory(client)
add_subdirectory(server)
add_subdirectory(main)
if (UNITTESTS)
	add_subdirectory(tests)
endif()
if (TOOLS)
	add_subdirectory(tools)
endif()

=== src/miniracer/CMakeLists.txt ===
add_subdirectory(shared)
add_subdirectory(client)
add_subdirectory(server)
add_subdirectory(main)
if (UNITTESTS)
	add_subdirectory(tests)
endif()

=== src/caveexpress/main/CMakeLists.txt ===
project(caveexpress)
set(TPS
	caveexpress-entity
	caveexpress-environment-ice
	caveexpress-environment
	caveexpress-npc_blowing
	caveexpress-npc_fish
	caveexpress-npc_flying
	caveexpress-npc_grandpa
	caveexpress-npc_mammut
	caveexpress-npc_man
	caveexpress-npc_walking
	caveexpress-npc_woman
	caveexpress-packagetarget-ice
	caveexpress-packagetarget-rock
	caveexpress-ui-dead
	caveexpress-ui-fonts
	caveexpress-ui-npc-mammut
	caveexpress-ui-player-grandpa
	caveexpress-ui-scene
	caveexpress-ui
)
cp_add_executable(TARGET ${PROJECT_NAME} TPS ${TPS} SRCS CaveExpress.cpp ../../Main.cpp WINDOWED APPNAME "CaveExpress" VERSION 2.5 VERSION_CODE 31)
cp_target_link_libraries(TARGET ${PROJECT_NAME} LIBS ${PROJECT_NAME}-server ${PROJECT_NAME}-client ${PROJECT_NAME}-shared game)
set(LUAFILES config.lua entities.lua entitysounds.lua fonts.lua sprites.lua textures/complete.lua)
check_lua_files(${PROJECT_NAME} "${LUAFILES}")

=== src/cavepacker/main/CMakeLists.txt ===
project(cavepacker)
set(TPS
	cavepacker-entity
	cavepacker-environment
	cavepacker-ui-fonts
	cavepacker-ui-scene
	cavepacker-ui
)
cp_add_executable(TARGET ${PROJECT_NAME} TPS ${TPS} SRCS CavePacker.cpp ../../Main.cpp WINDOWED APPNAME "CavePacker" VERSION 1.5 VERSION_CODE 11)
cp_target_link_libraries(TARGET ${PROJECT_NAME} LIBS ${PROJECT_NAME}-server ${PROJECT_NAME}-client ${PROJECT_NAME}-shared game)
set(LUAFILES config.lua fonts.lua sprites.lua textures/complete.lua)
check_lua_files(${PROJECT_NAME} "${LUAFILES}")

=== src/cavepacker/tests/CMakeLists.txt ===
set(NAME cavepacker)
project(tests_${NAME})
SET(${PROJECT_NAME}_SRC
	BoardStateTest.cpp
	MapManagerTest.cpp
	ProtocolTest.cpp
	SokobanMapContextTest.cpp
	SokobanMapTest.cpp
	CampaignTest.cpp
	PathfindingTest.cpp
	SolutionUtilTest.cpp
	../main/CavePacker.cpp
	../../tests/TestAll.cpp
	../../tests/TestShared.cpp
	../../tests/NetworkTest.cpp
	../../tests/NoNetworkTest.cpp
)
cp_add_executable(TARGET ${PROJECT_NAME} SRCS ${${PROJECT_NAME}_SRC} APPNAME ${PROJECT_NAME} VERSION 1.0 VERSION_CODE 1)
cp_target_link_libraries(TARGET ${PROJECT_NAME} LIBS ${NAME}-client ${NAME}-server ${NAME}-shared gtest)
add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})

=== src/miniracer/client/CMakeLists.txt ===
set(NAME miniracer)
set(${NAME}-client_SRCS
	ui/nodes/UINodeMap.cpp
	ui/windows/UIMiniRacerMapOptionsWindow.cpp
	ui/windows/UIMainWindow.cpp
	ui/windows/UIMapWindow.cpp
	MiniRacerClientMap.cpp
)
add_library(${NAME}-client ${${NAME}-client_SRCS})
set_target_properties(${NAME}-client PROPERTIES FOLDER ${NAME}-client)
cp_target_link_libraries(TARGET ${NAME}-client LIBS client ${NAME}-shared)

=== src/miniracer/server/CMakeLists.txt ===
set(miniracer-server_SRCS
	map/Map.cpp
	entities/MapTile.cpp
	entities/IEntity.cpp
	entities/Player.cpp
)
add_library(miniracer-server ${miniracer-server_SRCS})
set_target_properties(miniracer-server PROPERTIES FOLDER miniracer-server)
cp_target_link_libraries(TARGET miniracer-server LIBS mainloop miniracer-shared)

=== src/miniracer/shared/CMakeLists.txt ===
set(miniracer-shared_SRCS
	MiniRacerAnimation.cpp
	MiniRacerSQLitePersister.cpp
	MiniRacerSpriteType.cpp
	MiniRacerAchievement.cpp
	MiniRacerEntityType.cpp
)
add_library(miniracer-shared ${miniracer-shared_SRCS})
set_target_properties(miniracer-shared PROPERTIES FOLDER miniracer-shared)
cp_target_link_libraries(TARGET miniracer-shared LIBS campaign common network)

=== src/modules/common/CMakeLists.txt ===
set(common_SRCS
	ConfigPersisterSQL.cpp
	ThemeType.cpp
	KeyValueParser.cpp
	TextureDefinition.cpp
	IConsole.cpp
	String.cpp
	SQLite.cpp
	Thread.cpp
	ConfigManager.cpp
	EventHandler.cpp
	MemoryAllocator.cpp
	TextConsole.cpp
	MapManager.cpp
	FileSystem.cpp
	LUA.cpp
	LUAMapContext.cpp
	Log.cpp
	TimeManager.cpp
	ExecutionTime.cpp
	File.cpp
	ConsoleFrontend.cpp
	ConfigVar.cpp
	CommandSystem.cpp
	SpriteDefinition.cpp
	URI.cpp
	ByteStream.cpp
)

if(WINDOWS)
	set(ports_SRCS ports/Windows.cpp)
elseif(ANDROID)
	set(ports_SRCS ports/Unix.cpp ports/Android.cpp)
elseif(NACL)
	set(ports_SRCS ports/NaCl.cpp)
elseif(IOS)
	set(ports_SRCS ports/Unix.cpp ports/IOS.cpp ports/IOSObjc.mm)
elseif(DARWIN)
	set(ports_SRCS ports/Unix.cpp ports/Darwin.cpp ports/DarwinObjc.mm)
elseif(EMSCRIPTEN)
	set(ports_SRCS ports/Unix.cpp ports/HTML5.cpp)
elseif(UNIX)
	set(ports_SRCS ports/Unix.cpp)
	add_definitions(-D_GNU_SOURCE -D_BSD_SOURCE -D_XOPEN_SOURCE)
endif()

add_library(common ${common_SRCS} ${ports_SRCS})
set_target_properties(common PROPERTIES FOLDER common)
cp_target_link_libraries(TARGET common LIBS ${LUA5.2_LIBRARIES} ${SDL2_LIBRARIES} ${SQLITE3_LIBRARIES} ${BOX2D_LIBRARIES} ${GLM_LIBRARIES} ${CURSES_LIBRARIES})

=== src/modules/gfx/CMakeLists.txt ===
set(gfx_SRCS
	AbstractGLFrontend.cpp
	SDLFrontend.cpp
	GL3Frontend.cpp
	GLFunc.cpp
	FrameBuffer.cpp
	Shader.cpp
)
if (NOT ANDROID)
list(APPEND gfx_SRCS
	GL1Frontend.cpp
	BGFXFrontend.cpp
)
endif()
add_library(gfx ${gfx_SRCS})
set_target_properties(gfx PROPERTIES FOLDER gfx)
set(DEPS common texture ui)
if (ANDROID)
	list(APPEND DEPS GLESv1_CM GLESv2)
endif()
cp_target_link_libraries(TARGET gfx LIBS ${DEPS})

=== src/modules/network/CMakeLists.txt ===
set(network_SRCS
	NoNetwork.cpp
	Network.cpp
	ProtocolMessageFactory.cpp
	INetwork.cpp
)
add_library(network ${network_SRCS})
set_target_properties(network PROPERTIES FOLDER network)
cp_target_link_libraries(TARGET network LIBS SDL2_net common)

=== debian/changelog ===
caveexpress (2.4+git20160609-4) unstable; urgency=medium

  * d/copyright: Use https for Format field.
  * Declare compliance with Debian Policy 4.1.2.
  * Install appdata files into /usr/share/metainfo.
  * Add valid-appdata.patch and create a valid appdata file.

 -- Markus Koschany <apo@debian.org>  Sun, 10 Dec 2017 20:57:51 +0100

caveexpress (2.4+git20160609-3) unstable; urgency=medium

  * Tighten dependency on -data packages.
  * Switch to compat level 10.
  * Add map-second-ice-04.patch and fix package spawn issue on ice 04 map.
    Thanks to Guillaume Allais for the report. (Closes: #847147)

 -- Markus Koschany <apo@debian.org>  Thu, 08 Dec 2016 22:13:23 +0100

caveexpress (2.4+git20160609-2) unstable; urgency=medium

  * cavepacker,caveexpress: Depend on the data packages.
    Thanks to Armin Haas for the report. (Closes: #829615, #829616)
  * Enable CMAKE_VERBOSE_MAKEFILE option.

 -- Markus Koschany <apo@debian.org>  Mon, 04 Jul 2016 20:12:21 +0200

caveexpress (2.4+git20160609-1) unstable; urgency=medium

  * Initial release (Closes: #775743)

 -- Markus Koschany <apo@debian.org>  Sun, 03 Jul 2016 22:09:26 +0200

=== debian/control ===
Source: caveexpress
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Markus Koschany <apo@debian.org>
Build-Depends:
 cmake,
 debhelper (>= 10),
 libbox2d-dev,
 libglm-dev,
 libgtest-dev,
 liblua5.2-dev,
 libncurses5-dev,
 libsdl2-dev,
 libsdl2-image-dev,
 libsdl2-mixer-dev,
 libsdl2-net-dev,
 libsqlite3-dev,
 libtinyxml2-dev,
 libyajl-dev,
 lua5.2,
 pkg-config,
 zlib1g-dev
Standards-Version: 4.1.2
Homepage: http://www.caveproductions.org
Vcs-Git: https://anonscm.debian.org/git/pkg-games/caveexpress.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/caveexpress.git

Package: caveexpress
Architecture: any
Depends:
 caveexpress-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: 2D platformer with physics-based gameplay
 CaveExpress is a classic 2D platformer with physics-based gameplay
 and dozens of levels. Master your pedal-powered flying machine to
 pick up packages from your cave-dwelling clients and drop them off
 at the collection point.
 .
 But beware! Mighty mastodons, terrifying pterodactyls and others
 would rather see you extinct.

Package: caveexpress-data
Architecture: all
Depends:
 ${misc:Depends}
Suggests:
 caveexpress
Description: 2D platformer with physics-based gameplay --data
 CaveExpress is a classic 2D platformer with physics-based gameplay
 and dozens of levels. Master your pedal-powered flying machine to
 pick up packages from your cave-dwelling clients and drop them off
 at the collection point.
 .
 This package contains the data files needed to play CaveExpress.

Package: cavepacker
Architecture: any
Depends:
 cavepacker-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: sokoban game with network based multiplayer gaming
 CavePacker is a sokoban game. It is a puzzle game where you have to move the
 packages onto their targets without getting stuck. The lesser steps you made
 for solving a level, the better. You may only push but not pull packages.

Package: cavepacker-data
Architecture: all
Depends:
 ${misc:Depends}
Suggests:
 cavepacker
Description: sokoban game with network based multiplayer gaming --data
 CavePacker is a sokoban game. It is a puzzle game where you have to move the
 packages onto their targets without getting stuck. The lesser steps you made
 for solving a level, the better. You may only push but not pull packages.
 .
 This package contains the data files needed to play CavePacker.

=== debian/rules ===
#!/usr/bin/make -f
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export CCACHE_DIR=$(CURDIR)/ccache

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DNETWORKING=ON \
		-DUNITTESTS=OFF \
		-DTOOLS=OFF \
		-DVERBOSE=ON \
		-DCOVERAGE=OFF \
		-DUSE_CCACHE=ON \
		-DCAVEEXPRESS=ON \
		-DCAVEPACKER=ON \
		-DMINIRACER=OFF \
		-DCMAKE_VERBOSE_MAKEFILE=ON \
		-DPKGDATADIR=/usr/share/games

override_dh_installchangelogs:
	dh_installchangelogs docs/caveexpress/CHANGELOG

## caveexpress 2.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,6 +11,10 @@
 option(VERBOSE "Print debug information" OFF)
 option(COVERAGE "Compile with test coverage" OFF)
 option(USE_CCACHE "Use ccache" ON)
+# The build system will search for system libs, if it can't find them (e.g. via pkg-config)
+# it will take those that are bundled under src/libs. If you don't want that for some reason,
+# you can set this to ON and the libs dir will not be taken into account at all.
+option(FORCE_USE_SYSTEM_LIBS "Use system libs" OFF)
 option(CAVEEXPRESS "Build caveexpress" ON)
 option(CAVEPACKER "Build cavepacker" ON)
 option(MINIRACER "Build miniracer" OFF)
@@ -103,8 +107,15 @@
 # on mac it e.g. finds the gui launcher - this is not what we want - find a proper way to handle this
 if (NOT ${CMAKE_HOST_SYSTEM_NAME} STREQUAL "Darwin")
 	find_host_program(TEXTUREPACKER_BIN NAMES TexturePacker)
-	if (${TEXTUREPACKER_BIN})
-		message(STATUS "Found TexturePacker: ${TEXTUREPACKER_BIN}")
+	if (TEXTUREPACKER_BIN)
+		execute_process(COMMAND ${TEXTUREPACKER_BIN} --format CaveExpress ERROR_VARIABLE TEXTURE_PACKER_EXPORTER)
+		if (TEXTURE_PACKER_EXPORTER MATCHES "Unknown format")
+			message(STATUS "Found TexturePacker: ${TEXTUREPACKER_BIN}")
+			message(WARNING "but without the needed exporter. Find it in contrib/assets/png-packed/exporter. Check out the HOWTO.md in that directory.")
+			unset(TEXTUREPACKER_BIN)
+		else()
+			message(STATUS "Found TexturePacker: ${TEXTUREPACKER_BIN}")
+		endif()
 	else()
 		message(STATUS "Could not find TexturePacker")
 	endif()
@@ -135,9 +146,8 @@
 
 if (PKGDATADIR)
 	add_definitions(-DPKGDATADIR="${PKGDATADIR}")
-	message(STATUS "You specified a package data dir - but this means, you have to rebuild for each game.")
-	message(STATUS "If you don't do this, you get all the data of all the games in the same directory.")
-	message(STATUS "See the available options and disable all but one game for each build.")
+	message(STATUS "You specified a package data dir - the game will append the game name to this directory.")
+	message(STATUS "So you get e.g. ${PKGDATADIR}/caveexpress as final directory.")
 endif()
 
 if (NOT NETWORKING)
@@ -169,12 +179,23 @@
 
 include_directories(src)
 include_directories(src/modules)
-if (UNITTESTS)
-	include_directories(src/libs/gtest)
-	include_directories(src/libs/gtest/include)
-endif()
-
-add_subdirectory(src/libs)
+# Packagers might want to remove this
+if (EXISTS "${ROOT_DIR}/src/libs/" AND NOT FORCE_USE_SYSTEM_LIBS)
+	if (UNITTESTS)
+		include_directories(src/libs/gtest)
+		include_directories(src/libs/gtest/include)
+	endif()
+
+	add_subdirectory(src/libs)
+else()
+	include(FindPkgConfig)
+	PKG_SEARCH_MODULE(SDL2 REQUIRED sdl2<=2.0.3)
+	PKG_SEARCH_MODULE(SDL2IMAGE REQUIRED SDL2_image>=2.0.0)
+	PKG_SEARCH_MODULE(LUA5.2 REQUIRED lua5.2)
+	PKG_SEARCH_MODULE(BOX2D REQUIRED box2d>=2.3.0)
+	PKG_SEARCH_MODULE(SQLITE3 REQUIRED sqlite3)
+	include_directories(${SDL2_INCLUDE_DIRS} ${SDL2IMAGE_INCLUDE_DIRS})
+endif()
 
 # TODO move into lib cmakefiles
 if (LUA5.2_FOUND)

=== src/cavepacker/client/CMakeLists.txt ===
set(NAME cavepacker)
set(${NAME}-client_SRCS
	ui/nodes/UICavePackerNodePoint.cpp
	ui/nodes/UINodeMap.cpp
	ui/windows/UICavePackerMapOptionsWindow.cpp
	ui/windows/intro/IntroGame.cpp
	ui/windows/intro/IntroPathfinding.cpp
	ui/windows/intro/IntroDeadlock.cpp
	ui/windows/UIMainWindow.cpp
	ui/windows/UIMapWindow.cpp
	CavePackerClientMap.cpp
)
add_library(${NAME}-client ${${NAME}-client_SRCS})
set_target_properties(${NAME}-client PROPERTIES FOLDER ${NAME}-client)
cp_target_link_libraries(TARGET ${NAME}-client LIBS client ${NAME}-shared)

=== src/cavepacker/main/CMakeLists.txt ===
project(cavepacker)
set(TPS
	cavepacker-entity
	cavepacker-environment
	cavepacker-ui-fonts
	cavepacker-ui-scene
	cavepacker-ui
)
cp_add_executable(TARGET ${PROJECT_NAME} TPS ${TPS} SRCS CavePacker.cpp ../../Main.cpp WINDOWED APPNAME "CavePacker" VERSION 1.5 VERSION_CODE 11 Category LogicGame)
cp_target_link_libraries(TARGET ${PROJECT_NAME} LIBS ${PROJECT_NAME}-server ${PROJECT_NAME}-client ${PROJECT_NAME}-shared game)
set(LUAFILES config.lua fonts.lua sprites.lua textures/complete.lua)
check_lua_files(${PROJECT_NAME} "${LUAFILES}")

=== src/cavepacker/shared/CMakeLists.txt ===
set(cavepacker-shared_SRCS
	CavePackerAnimation.cpp
	CavePackerSQLitePersister.cpp
	CavePackerSpriteType.cpp
	CavePackerSoundType.cpp
	CavePackerAchievement.cpp
	CavePackerEntityType.cpp
	SolutionUtil.cpp
	Pathfinding.cpp
	BoardState.cpp
	deadlock/DeadlockDetector.cpp
	deadlock/SimpleDeadlockDetector.cpp
	deadlock/FrozenDeadlockDetector.cpp
	deadlock/CorralDetector.cpp
	deadlock/ClosedDiagonalDetector.cpp
	deadlock/BipartiteDetector.cpp
)
add_library(cavepacker-shared ${cavepacker-shared_SRCS})
set_target_properties(cavepacker-shared PROPERTIES FOLDER cavepacker-shared)
cp_target_link_libraries(TARGET cavepacker-shared LIBS common network)

=== src/modules/game/CMakeLists.txt ===
set(game_SRCS GameRegistry.cpp IGame.cpp)
add_library(game ${game_SRCS})
set_target_properties(game PROPERTIES FOLDER game)
cp_target_link_libraries(TARGET game LIBS common campaign)

=== src/modules/physics/CMakeLists.txt ===
set(physics_SRCS DebugRenderer.cpp)
add_library(physics ${physics_SRCS})
set_target_properties(physics PROPERTIES FOLDER physics)
cp_target_link_libraries(TARGET physics LIBS common ${BOX2D_LIBRARIES} ${SDL2_LIBRARIES})

=== src/modules/sound/CMakeLists.txt ===
set(sound_SRCS Sound.cpp SDLSoundEngine.cpp)
add_library(sound ${sound_SRCS})
set_target_properties(sound PROPERTIES FOLDER sound)
cp_target_link_libraries(TARGET sound LIBS SDL2_mixer common)

## caveexpress 2.5-dev2

=== debian/changelog ===
caveexpress (2.5-dev2-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:11:06 +0100

caveexpress (2.5-dev2-1) unstable; urgency=medium

  * New upstream version 2.5-dev2.
  * Switch to debhelper-compat = 12.
  * Use canonical VCS URI.
  * Drop build.patch, desktop-file.patch, dataDir.patch,
    man-page-spelling.patch, use-system-Box2D.patch. Fixed upstream.

 -- Markus Koschany <apo@debian.org>  Sun, 17 Nov 2019 16:38:09 +0100

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
  Markus Koschany <apo@debian.org>
 Build-Depends:
  cmake,
- debhelper (>= 10),
+ debhelper-compat (= 12),
  libbox2d-dev,
  libglm-dev,
  libgtest-dev,
@@ -22,10 +22,10 @@
  lua5.2,
  pkg-config,
  zlib1g-dev
-Standards-Version: 4.1.2
+Standards-Version: 4.4.1
 Homepage: http://www.caveproductions.org
-Vcs-Git: https://anonscm.debian.org/git/pkg-games/caveexpress.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/caveexpress.git
+Vcs-Git: https://salsa.debian.org/games-team/caveexpress.git
+Vcs-Browser: https://salsa.debian.org/games-team/caveexpress
 
 Package: caveexpress
 Architecture: any

## caveexpress 2.5.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 2.8.7)
+cmake_minimum_required(VERSION 3.7)
 project(caveproductions)
 
 #-------------------------------------------------------------------------------
@@ -18,7 +18,8 @@
 option(CAVEEXPRESS "Build caveexpress" ON)
 option(CAVEPACKER "Build cavepacker" ON)
 option(MINIRACER "Build miniracer" OFF)
-option(SANITIZER "Build with sanitizer support if available" ON)
+option(SANITIZER "Build with sanitizer support if available" OFF)
+option(ANDROID_INSTALL_PACKAGES "Install required android packages" ON)
 
 #-------------------------------------------------------------------------------
 # end options
@@ -33,6 +34,11 @@
 	set(RELEASE False)
 else()
 	set(RELEASE True)
+endif()
+
+if (BUILD_SHARED_LIBS)
+	message(STATUS "Forcing building the internal libraries as static, even though BUILD_SHARED_LIBS=ON was requested.")
+	set(BUILD_SHARED_LIBS OFF)
 endif()
 
 set(ROOT_DIR ${CMAKE_CURRENT_SOURCE_DIR} CACHE STRING "Root dir")
@@ -96,6 +102,8 @@
 	set(LINUX 1)
 elseif (${CMAKE_SYSTEM_NAME} STREQUAL "Emscripten")
 	set(EMSCRIPTEN 1)
+elseif (${CMAKE_SYSTEM_NAME} STREQUAL "Haiku")
+	set(HAIKU 1)
 else()
 	message(WARNING "Unknown host system: ${CMAKE_SYSTEM_NAME}. Default to linux")
 	set(LINUX 1)
@@ -125,6 +133,8 @@
 		include(${CP_CMAKE_DIR}/toolchains/windows-toolchain.cmake)
 	elseif (DARWIN)
 		include(${CP_CMAKE_DIR}/toolchains/darwin-toolchain.cmake)
+	elseif (HAIKU)
+		include(${CP_CMAKE_DIR}/toolchains/haiku-toolchain.cmake)
 	else()
 		include(${CP_CMAKE_DIR}/toolchains/linux-toolchain.cmake)
 	endif()
@@ -142,6 +152,8 @@
 	include(${CP_CMAKE_DIR}/nacl.cmake)
 elseif (EMSCRIPTEN)
 	include(${CP_CMAKE_DIR}/emscripten.cmake)
+elseif (HAIKU)
+#	include(${CP_CMAKE_DIR}/haiku.cmake)
 endif()
 
 if (PKGDATADIR)
@@ -189,7 +201,7 @@
 	add_subdirectory(src/libs)
 else()
 	include(FindPkgConfig)
-	PKG_SEARCH_MODULE(SDL2 REQUIRED sdl2<=2.0.3)
+	PKG_SEARCH_MODULE(SDL2 REQUIRED sdl2>=2.0.3)
 	PKG_SEARCH_MODULE(SDL2IMAGE REQUIRED SDL2_image>=2.0.0)
 	PKG_SEARCH_MODULE(LUA5.2 REQUIRED lua5.2)
 	PKG_SEARCH_MODULE(BOX2D REQUIRED box2d>=2.3.0)

=== src/modules/CMakeLists.txt ===
add_subdirectory(common)
add_subdirectory(network)
add_subdirectory(service)
add_subdirectory(game)
add_subdirectory(campaign)
add_subdirectory(sound)
add_subdirectory(textures)
add_subdirectory(sprites)
add_subdirectory(particles)
add_subdirectory(physics)
add_subdirectory(gfx)
add_subdirectory(ui)
add_subdirectory(mainloop)
add_subdirectory(client)

=== src/tests/CMakeLists.txt ===
project(tests)
textures(${PROJECT_NAME})
set(${PROJECT_NAME}_SRC
	ByteStreamTest.cpp
	EnumTest.cpp
	FileTest.cpp
	GeneralTest.cpp
	LUATest.cpp
	MemoryAllocatorTest.cpp
	NetworkTest.cpp
	NoNetworkTest.cpp
	ParticleTest.cpp
	SQLiteTest.cpp
	SystemTest.cpp
	TestAll.cpp
	TestGame.cpp
	TestShared.cpp
	TimeManagerTest.cpp
	UITest.cpp)
cp_add_executable(TARGET ${PROJECT_NAME} SRCS ${${PROJECT_NAME}_SRC} APPNAME Tests VERSION 1.0 VERSION_CODE 1)
cp_target_link_libraries(TARGET ${PROJECT_NAME} LIBS common client game network ui gtest)
add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})

=== src/cavepacker/server/CMakeLists.txt ===
set(cavepacker-server_SRCS
	map/SokobanMapContext.cpp
	map/Map.cpp
	entities/MapTile.cpp
	entities/IEntity.cpp
	entities/Player.cpp
)
add_library(cavepacker-server ${cavepacker-server_SRCS})
set_target_properties(cavepacker-server PROPERTIES FOLDER cavepacker-server)
cp_target_link_libraries(TARGET cavepacker-server LIBS mainloop cavepacker-shared)

=== src/cavepacker/tools/CMakeLists.txt ===
project(solutiontool)
SET(${PROJECT_NAME}_SRC SolutionTool.cpp)
add_executable(${PROJECT_NAME} ${${PROJECT_NAME}_SRC})
set_target_properties(${PROJECT_NAME} PROPERTIES FOLDER ${PROJECT_NAME})
cp_target_link_libraries(TARGET ${PROJECT_NAME} LIBS cavepacker-shared common)

=== src/miniracer/main/CMakeLists.txt ===
project(miniracer)
cp_add_executable(TARGET ${PROJECT_NAME} SRCS MiniRacer.cpp ../../Main.cpp WINDOWED APPNAME "MiniRacer" VERSION 1.4 VERSION_CODE 9)
cp_target_link_libraries(TARGET ${PROJECT_NAME} LIBS ${PROJECT_NAME}-server ${PROJECT_NAME}-client ${PROJECT_NAME}-shared game)
set(TPS
	miniracer-{n}
)
texturepacker(PROJECTNAME ${PROJECT_NAME} FILELIST ${TPS})
textures(${PROJECT_NAME})
create_dir_header(${PROJECT_NAME})

=== src/modules/common/CMakeLists.txt ===
--- 
+++ 
@@ -41,7 +41,7 @@
 	set(ports_SRCS ports/Unix.cpp ports/HTML5.cpp)
 elseif(UNIX)
 	set(ports_SRCS ports/Unix.cpp)
-	add_definitions(-D_GNU_SOURCE -D_BSD_SOURCE -D_XOPEN_SOURCE)
+	add_definitions(-D_GNU_SOURCE -D_DEFAULT_SOURCE -D_XOPEN_SOURCE)
 endif()
 
 add_library(common ${common_SRCS} ${ports_SRCS})

=== src/modules/mainloop/CMakeLists.txt ===
set(mainloop_SRCS SDLMainLoop.cpp)
add_library(mainloop ${mainloop_SRCS})
set_target_properties(mainloop PROPERTIES FOLDER mainloop)
cp_target_link_libraries(TARGET mainloop LIBS common game network client service)

=== src/modules/service/CMakeLists.txt ===
set(service_SRCS ServiceProvider.cpp)
add_library(service ${service_SRCS})
set_target_properties(service PROPERTIES FOLDER service)
cp_target_link_libraries(TARGET service LIBS network common game)

=== src/modules/sprites/CMakeLists.txt ===
set(sprite_SRCS Sprite.cpp SpriteCache.cpp)
add_library(sprite ${sprite_SRCS})
set_target_properties(sprite PROPERTIES FOLDER sprite)
cp_target_link_libraries(TARGET sprite LIBS common texture)

=== debian/changelog ===
caveexpress (2.5.1-1) unstable; urgency=medium

  * New upstream version 2.5.1.
  * Drop all patches. Fixed upstream.
  * Switch to debhelper-compat = 13.
  * Declare compliance with Debian Policy 4.5.0.

 -- Markus Koschany <apo@debian.org>  Mon, 18 May 2020 10:28:50 +0200

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
  Markus Koschany <apo@debian.org>
 Build-Depends:
  cmake,
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  libbox2d-dev,
  libglm-dev,
  libgtest-dev,
@@ -22,7 +22,7 @@
  lua5.2,
  pkg-config,
  zlib1g-dev
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Homepage: http://www.caveproductions.org
 Vcs-Git: https://salsa.debian.org/games-team/caveexpress.git
 Vcs-Browser: https://salsa.debian.org/games-team/caveexpress

=== debian/rules ===
--- 
+++ 
@@ -23,3 +23,5 @@
 override_dh_installchangelogs:
 	dh_installchangelogs docs/caveexpress/CHANGELOG
 
+override_dh_missing:
+	dh_missing --list-missing
